%% CLPQ support for Curry.

:- module('Clpqlib', []).

:- use_module('Core', [tonf/2, tohnf/2]).

:- multifile     user_tohnf/2, user_tonf/2.
:- discontiguous user_tohnf/2, user_tonf/2.

%% We are going to support clpq.
:- use_package(clpq).

%% Integer operations.
user_tohnf('Clpq_:+:'(D, E)#B, B) :- 
	!,
	tonf(D,F),
	tonf(E,G),
	B .=. F+G.

user_tohnf('Clpq_:-:'(D, E)#B, B) :-
	!,
	tonf(D,F),
	tonf(E,G),
	B .=. F-G.

user_tohnf('Clpq_:*:'(D, E)#B, B) :-
	!,
	tonf(D,F),
	tonf(E,G),
	B .=. F*G.

%% Comparison operators.

user_tohnf('Clpq_:<:'(D, E)#B, B) :-
	!,
	tonf(D,F),
	tonf(E,G),
	F .<. G,
	B = 'Prelude_Success'.

user_tohnf('Clpq_:>:'(D, E)#B, B) :- 
	!,
	tonf(D,F),
	tonf(E,G),
	F .>. G,
	B = 'Prelude_Success'.

user_tohnf('Clpq_:>=:'(D, E)#B, B) :-
	!,
	tonf(D,F),
	tonf(E,G),
	F .>=. G,
	B = 'Prelude_Success'.

user_tohnf('Clpq_:<=:'(D, E)#B, B) :-
	!,
	tonf(D,F),
	tonf(E,G),
	F .=<. G,
	B = 'Prelude_Success'.
