%% Fd support for Curry.

:- module('Fdlib', []).

:- use_module('Core', [tonf/2, tohnf/2]).

:- multifile     user_tohnf/2, user_tonf/2.
:- discontiguous user_tohnf/2, user_tonf/2.

%% We are going to support fd.
:- use_package(fd).

%% The support is incomplete, and Ciao version is evolving yet.
user_tohnf('Fd_in_range'(A, 'Prelude_,'(R1, R2))#A1, R) :-
	tonf(A, A1),
	A1 in R1..R2,
	R = 'Prelude_Success'.

user_tonf(A + B, R) :-
	tonf(A, A1),
	tonf(B, B1),
	R = A1 + B1.

user_tonf(A - B, R) :-
	tonf(A, A1),
	tonf(B, B1),
	R = A1 - B1.

user_tohnf('Fd_.+.'(A, B)#R, R) :-
	R = (A + B).

user_tohnf('Fd_.-.'(A, B)#R, R) :-
	R = (A - B).

user_tohnf('Fd_.<.'(A, B)#R, R) :-
	tonf(A, A1),
	tonf(B, B1),
	A1 .<. B1,
	R = 'Prelude_Success'.

user_tohnf('Fd_.=<.'(A, B)#R, R) :-
	tonf(A, A1),
	tonf(B, B1),
	A1 .=<. B1,
	R = 'Prelude_Success'.

user_tohnf('Fd_.>.'(A, B)#R, R) :-
	tonf(A, A1),
	tonf(B, B1),
	A1 .>. B1,
	R = 'Prelude_Success'.

user_tohnf('Fd_.>=.'(A, B)#R, R) :-
	tonf(A, A1),
	tonf(B, B1),
	A1 .>=. B1,
	R = 'Prelude_Success'.

user_tohnf('Fd_.=.'(A, B)#R, R) :-
	tonf(A, A1),
	tonf(B, B1),
	A1 .=. B1,
	R = 'Prelude_Success'.

user_tohnf('Fd_.<>.'(A, B)#R, R) :-
	tonf(A, A1),
	tonf(B, B1),
	A1 .<>. B1,
	R = 'Prelude_Success'.

%% Labelling predicates.
user_tohnf('Fd_all_different'(List)#R, R) :-
	tonf(List, List1),
	all_different(List1),
	R = List1.

user_tohnf('Fd_labeling'(List)#R, R) :-
	tonf(List, List1),
	labeling(List1),
	R = List1.
