:- module(cshell, [cshell/0], _).

% Library imports.

:- use_module(library(streams)).
:- use_module(library(lists)).
:- use_module(library(dynamic)).
:- use_module(library(write)).
:- use_module(library(dec10_io)).
:- use_module(library(aggregates)).
:- use_module(library(terms_vars)).
:- use_module(library(compiler)).

% Old imports.
% Will try to clean up.
:-include(nfhnf).

:-use_module(parser).
:-use_module(typer).
:-use_module(symtab).
:-use_module(deftree).
:-use_module(trad).
:-use_module(typer).
:-use_module(trans_lazy).

% New imports.
:- use_module(error, [do_error/1]).

% Sloth
welcome_message :-	
	write('
Welcome to Proto Curry (SLOTH)
Facultad de Informtica UPM.  http://babel.ls.fi.upm.es
Campus de Montegancedo s/n 28660 Boadilla del Monte
Madrid (SPAIN)

Shell version 0.1.1-egallego\n').

 
initialize :-
	prolog_flag(single_var_warnings,_,off),
	%prolog_flag(redefine_warnings,_,off), % Este dice que no.... creo que redefine_warning no es flag 
	nofileerrors, 
	retractall(symtab(_,_,_)),
	init_scanner,			% Actualizar a los predicados 
	predefineds,
	welcome_message,
	prompt(_,'Curry>'),
	retractall(smode(_)),assert(smode(interactive)).


cshell :-
	initialize,
	catch('<interactive_program>', E, do_interactive_error(E)).

% Generic exception catching for the shell.
% Add catch cases as necesary.

% do_interactive_error( functor(args) ) :- blah.

% If error is unknown, better forward it.
do_interactive_error(E) :-
	do_error(E).

'<interactive_program>':-
   write('inirama2'),nl,
   %retractall(smode(_)),assert(smode(interactive)), %%%%%%%% PRUEBA
   token_have(end_rule),!,write('finrama2'),nl,
   '<interactive_program>'.

'<interactive_program>':-
   write('inirama1'),nl,
   %retractall(smode(_)),assert(smode(interactive)), %%%%%%%% PRUEBA
%   prompt(_,'Curry>'),
   token_have(op(:)),!,
   command,
   write('finrama1'),nl,
   '<interactive_program>'.


 '<interactive_program>':-
   write('inirama3'),nl,%!,
   %retractall(smode(_)),assert(smode(interactive)), %%%%%%%% PRUEBA
   deleteobj('@Type_data'),
   current_input(Input),   
   line_count(Input,Line),% write(Line),		linea anterior
   update('@Type_data',current_func,'User_Input'),
   update('@Type_data',current_rule,Line),
   allobj(function,Functions),
   allobj(constructor,Constructors),
   append(Functions,Constructors,Ids),
   ('<expr>'(Expr)->
 %% trace,
    cambia_id_vars_exp(Expr,[[],unit,'.',mod,div|Ids],ExprVars),
    cambia_lambdas_exp(ExprVars,ExprVarsLambdas),
    (body_type(ExprVarsLambdas,_,_)
     -> true
     ;
     type_error('Unable to infer a type for that expression. Is it malformed?',[]));
    true),
   ((error_condition;type_error_condition) ->
   (show_syntax_errors,nl,show_type_errors,
   clear_syntax_errors,clear_type_errors,
   retractall(token(_)),retractall(lacs(_)),assert(lacs([]))) 
   ;
   (retractall(token(_)),retractall(lacs(_)),assert(lacs([])),
   trans_exp_lazy(ExprVarsLambdas,prolog(_,Bt)),
   symtab2pro(Bt,BtPro,Dicc),
%    (exec(BtPro,Dicc)->true;write('No'),nl),prompt(_,'Curry>'))),
    (exec(BtPro,Dicc)->true;write('No')))),
   write('finrama3'),nl, %resynch([end_rule]),   %Prueba
   '<interactive_program>'.
 

 command:-		%%% Sale de Curry y Ciao
   token_have(id(q)),!,
   nl,
   write('Leaving Curry.'),nl,
   halt.

 command:-
   token_have(id(l)),!,
   retractall(smode(_)),assert(smode(batch)), %%%%%%%% PRUEBA  
   get_filename(ProgramChars),	
   %write('Entra en :l'),nl,			
   name(Program,ProgramChars),
   %write('El nombre del programa es: '),write(Program),nl,
   append(ProgramChars,[95,95,46,112,108],CurryProgramChars),
   name(CurryProgram,CurryProgramChars),
   %write('El nombre del programa es: '),write(CurryProgram),nl,
   % (curry2pro_lazy(Program,CurryProgram) linea anterior
    (compila(Program,CurryProgram) 
   ->
     (write('intenta compilar '),
     %abolish(goal),
     %abolish(tonf),		Comentarios mios.
     %abolish(tohnf),
     
     ( \+ensure_loaded(CurryProgram)		% Esta es la linea q no tira incluir libreria
        ->
       write('Program not loaded due to errors.'),nl ;
      true,
     parse(Program), % Recargar la tabla de simbolos
     findall(F,(lookup(F,class,function),\+forbidden(F)),Fs),
     nl,
     write('Functions defined in '),write(Program),write(': '),write(Fs)),
     %swritef(Mess,"Functions defined in %w: %w.",[Program,Fs]),
     %write(Mess)),
     retractall(lacs(_)),assert(lacs([])),
     nl,
     clear_syntax_errors,clear_type_errors,
     retractall(smode(_)),assert(smode(interactive))) %%%%%%%% PRUEBA
   ;
     (nl,write('Could not open file to load.'),nl))
     ,resynch([eof,end_rule]).   %Prueba

 command:-
   token_have(id(s)),!, % Shell de Prolog.
%   break,				% No es predicado en ciao
   resynch([eof,end_rule]).

command:-		%% Dice el tipo de una expresión(En teoria)
  token_have(id(t)),!,
  (token_have(id(Function)) -> 
  (lookup(Function,defType,Type)
  ->
    adapt_type(Type,Typea),nl,write(Typea),nl
  ;
    nl,write(Function),write(' is not defined.'),nl);true),
  resynch([eof,end_rule]).

% command:-
%   token_have(id(t)),!,
%  deleteobj('@Type_data'),
%   line_count(Input,Line),		% No le gusta nada el primer arg creo q no deberia entrar
%   update('@Type_data',current_func,'User_Input'),
%   update('@Type_data',current_rule,Line),
%   allobj(function,Functions),
%   allobj(constructor,Constructors),
%   append(Functions,Constructors,Ids),
%   ('<expr>'(Expr)-> 
%    cambia_id_vars_exp(Expr,[[],unit,'.',mod,div|Ids],ExprVars),
%    cambia_lambdas_exp(ExprVars,ExprVarsLambdas),
%    body_type(ExprVarsLambdas,BType,_),
%    adapt_type(BType,BTypea);
%    true),
%   ((error_condition;type_error_condition) ->
%    (show_syntax_errors,nl,show_type_errors)
%  ;
%  (write(BTypea),nl)),
%   retractall(token(_)),retractall(lacs(_)),assert(lacs([])).

  

 command:-
   token_have(id(e)),!,
   (token_have(id(Function)) ->
   (lookup(Function,class,function)
   ->
     (lookup(Function,eval,Ev) ->
       write(Ev),nl
     ;
	write(Function),write(' has no evaluation annotation. All positions are flex.'),nl,nl)
       %swritef(Mess,"%w has no evaluation annotation. All positions are flex.",[Function]),nl,write(Mess),nl)
   ;
     nl,write(Function),write(' is not defined.'),nl);true),
   resynch([eof,end_rule]).

 command:-
   resynch([eof,end_rule]),
   nl,write('Invalid command'),nl.





% %%%%%%%%%%%%%%%%%%%% Shell de Curry: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 get_filename(Chars):-
   
   get0(F),
   %%  (F==10 -> Chars=[] ; get_filename(RChars),Chars=[F|RChars]).%% no se para F==10?????
   (F=='\n' -> Chars=[] ; get_filename(RChars),name(F,[F2]),Chars=[F2|RChars]).
 


 adapt_type(T,Tadapted):- % Pasa un tipo del formato de symtab al de Curry
   convert_func_list(T,Tlist), % Ej: list(A) ->A ->B  (A,B libres) pasa a:
   rename_vars_list(Tlist,[],_Vars), % [a]->a->b
   adapt_type_list(Tlist,TadaptedList),
   convert_list_func(TadaptedList,Tadapted).

 adapt_type_list([],[]).
 adapt_type_list([list(A)|Ls],[[Aa]|Lsa]):-!,
   adapt_type(A,Aa),
   adapt_type_list(Ls,Lsa).
 adapt_type_list([A|Ls],[A|Lsa]):-
   adapt_type_list(Ls,Lsa).

 rename_vars_list([],Env,Env). % Liga las variables libres a minusculas
 rename_vars_list([T|Ts],Env,EnvOut):-
   rename_vars(T,Env,Env2),rename_vars_list(Ts,Env2,EnvOut).

 rename_vars(A,Env,[A|Env]):-
   var(A),!,
   length(Env,EnvLength),
   L1 is EnvLength+97,
   name(NextLetter,[L1]),
   A=NextLetter.
 rename_vars(Term,Env,EnvOut):-
   Term=..[_|Args],!,
   rename_vars_list(Args,Env,EnvOut).
 rename_vars(A,Env,Env):-
   \+(var(A)),!.
  
%Predicado que pasa del formato de prolog(Head,Body) a prolog definitivo
%Solo cambia num(N) a N y las var(xxx) a variable libre.
%Deja en paz las variables libres.

symtab2pro(num(N),N,_):-!.
symtab2pro(var(V),V,_):-var(V),!.
symtab2pro(var(VarTerm),V,Env):-!,
  member(VarTerm-V,Env).
symtab2pro(Term,TermPro,Env):-
  Term=..[Op|Args],!,
  name(Op,OpList),
  OpList=[L|Ls], % Poner los constructores con la 1a minuscula
  (L>=0'A,L=<0'Z -> % (Para que no sean variables de prolog)
   L2 is L+32,OpList2=[L2|Ls] ; OpList2=OpList),
  name(Op2,OpList2),
  symtab2pro_list(Args,ArgsPro,Env),
  TermPro=..[Op2|ArgsPro].
symtab2pro(Term,TermPro,Env):-
  Term=..[Op|Args],!,
                  % Poner los constructores entre comillas
                  % (Para que no sean variables de prolog
  symtab2pro_list(Args,ArgsPro,Env),
  TermPro=..[Op|ArgsPro].
symtab2pro(Term,Term,_).

symtab2pro_list([],[],_).
symtab2pro_list([T|Ts],[Tpro|Tspro],Env):-
  symtab2pro(T,Tpro,Env),symtab2pro_list(Ts,Tspro,Env).

 filter_variables([],[]):-!.
 filter_variables([loc(_)-_|Vs],Vfs):-!,
   filter_variables(Vs,Vfs).
 filter_variables([Var-_|Vs],Vfs):- % Quitar las var. Rxxx
   name(Var,[82|_]),!,
   filter_variables(Vs,Vfs).
 filter_variables([Var-Val|Vsadapt_type],[Var is Val|Vfs]):-
   filter_variables(Vs,Vfs).

 exec(Goal,Dicc):- 
   %prompt(_,''),
   write('Intenta Ejecutar:'),write(Goal),nl,
   Goal=tonf(_Exp,R1),
   filter_variables(Dicc,Dicc2), % Quita de la lista de variables que se le 
   varset(Dicc2,VarsGoal),                                   
   %call_residue(Goal,Res),                   % pasa las loc(_) y las Rn
   write(Goal),call(Goal),write('passa'),nl,		  %Lo he puesto yo
   %exec(Goal,Dicc2),
   %mark_block_vars(Res),  % Estos dos predicados estan en nfhnf.pl para
   mark_free_vars(Dicc2), % que los use tambien exec_batch
   varset(R1,VarsRes),
   unfree_vars(VarsRes,'<free>'), % este predicado esta en nfhnf.pl
   nl,write('Result: '),write(R1),nl,
   (VarsGoal==[]->true;write('Substitution: '),write(Dicc2),nl,
   nl,write('More?'),
   get_char(Answer),nl,
   %get(Answer),nl,		Linea anterior
   \+(Answer=0';)).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

