:- module(lambda, [desugar_lambdas/0, new_lambda/2]).

%
:- use_module(library(lists),   [append/3, length/2] ).

:- use_module(symtab,     [add_rule/2, set_object_property/3, get_object_property/3] ).
:- use_module(types,      [fake_type/2] ).
:- use_module(curryast,   [split_rule/3, map_rules/1, map_tree/3,
	                   get_function/2, get_params/2 ]).
:- use_module(combinator, [make_combinator/3, replace_comb/3] ).

:- include(ast_ops).

%% This commentary is half-accurate.

%% I don't know why Ciao doesn't reinstate asserted predicates when 
%% a search is in place, for more refence see util/bug3.pl, so we have 
%% to map the inner expression first.

desugar_lambdas :-
	map_rules(new_lambda).

%% Simple lambda lifting.
new_lambda(lambda(Pattern, E), NE) :-
        map_tree(E, new_lambda, ME),
	%% Create the lambda function.
	split_rule(LRule, Pattern, ME),
	make_combinator(LRule, LCombinator, rinfo(LName, Args)),
	NE = LName@Args,
	globalize_ldef_func(LCombinator).

globalize_ldef_func(Func) :-
	split_rule(Func, Head, _),
	get_function(Head, FName),
	add_rule(FName, Func),
	%% FIXME, we have no typer, ughh!
	(
 	    \+ get_object_property(FName, type, _) ->
	    get_params(Head, PC),
 	    length(PC, FakeArity),
	    fake_type(FakeArity, FakeType),
 	    set_object_property(FName, type, FakeType)
 	;
 	    true
 	).





%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

