:- module(scope, [open_scope/1, close_scope/0, lookup_symbol/2,
	          show_scope/0, lookup_symbol_unref/2,
	          insert_symbol/2, clean_scope/0, scope_name/1,
	          destroy_scope/1]).

:- use_module(library(dynamic),  [asserta/1, retract/1, retractall/1]).
:- use_module(library(dict),     [dic_lookup/3, dic_get/3, dic_replace/4] ).

%% 
:- data scope/2.

%% 

clean_scope :-
	retractall(scope(_,_)).

open_scope(Name) :-
	asserta(scope(Name, _Dict)),
	!.
	%write(opening_scope(Name)),
	%nl,
	%show_scope.
%% 
close_scope :-
	scope(Name, _Dict),
	%write(closing_scope(Name)),
	%nl,
	!,
	retract(scope(Name, _)).
	%show_scope.


%% !!!! Beware all the cuts are red.
	
lookup_symbol(Name, Object) :-
	scope(_, Dicc),
	dic_get(Dicc, Name, Object).

lookup_symbol_unref(Name, Object) :-
	scope(_, Dicc),
	dic_get(Dicc, Name, Object),
	!.

lookup_symbol_unref(Name, unref(Name)) :-
	!.

%% Strange implementation was this.
% lookup_symbol_unref(Name, unref(Name)) :-
% 	retract(scope(MName, Dicc)),
% 	!,
% 	dic_lookup(Dicc, Name, unref(Name)),
% 	asserta(scope(MName, Dicc)).
	
%%

insert_symbol(Name, Object) :-
	scope(SName, Dicc),
	!,
	(
	    dic_lookup(Dicc, Name, Object),
	    Dicc = Dicc2
	;
	    dic_replace(Dicc, Name, Object, Dicc2)
	),
	retract(scope(SName, _)),
	asserta(scope(SName, Dicc2)).

%%
show_scope :- 
	findall(N, scope(N, _), L),
	display(L),
	nl.

scope_name(Name) :-
	scope(Name, _).

%%
destroy_scope(Name) :-
	retractall(scope(Name, _)).

% show_scope :-
% 	scope(N, _D),
% 	display(scope(N)),
% 	display('\n'),
% 	fail.

% show_scope.

%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

